/**
* Xelfi programming environment
*/

package xelfi;
import xelfi.xedit.EditorFrame;
import xelfi.editor.keys.KeyOperator;
import java.io.FileInputStream;
import xelfi.util.Debug;

public abstract class PlainEditor {
  /** Opens editor. If arguments are specified, files are opened.
  * @param arg the files to open
  */
  public static void main (String arg[]) throws Exception {
    Debug.setDebugging (true);
//    FileInputStream is = new FileInputStream ("d:\\Xelfi\\xelfi\\editor\\actions\\Default.key");
    FileInputStream is = new FileInputStream ("/d/Xelfi/xelfi/editor/actions/Default.key");
    KeyOperator.load (is);
    is.close ();
//    System.out.println (KeyOperator.tableToString ());

    if (arg.length > 0) {
      for (int i = 0; i < arg.length; i++) {
        new EditorFrame (arg[i]).show ();
      };
    } else {
      new EditorFrame ().show ();
    };
  };
};





























