/**
* Xelfi programming environment
*/

package xelfi.editor;
/**
* Searches for first space character or end of line.
*
* @version 1.0
* @author Jaroslav Tulach
*/

class AcceptorSpace implements Acceptor {
  /** Searches for the first space character.
  * @param ch the character at specified position
  * @return false if ch is still not space
  */
  public boolean accept (char ch) {
    return !Character.isLetterOrDigit (ch);
  };
};
