package xelfi.editor.keys;
import java.awt.Event;

class Key implements KeyConstants {

  static KeyCode key (String s) throws ParseError {
    try {
      return keyDo ();
    } catch (ParseError er) {
      throw new ParseError ("In key code " + s);
    }
  }

/* Grammer begins here */
  static final public KeyCode keyDo() throws ParseError {
  KeyCode t;
    jj_consume_token(BEGIN);
    t = innerKey();
    jj_consume_token(END);
                                  return t;
  }

  static final public KeyCode innerKey() throws ParseError {
  KeyCode first;
  KeyCode last;
  KeyCode tmp;
    first = oneKey();
                     last = first;
    label_1:
    while (true) {
      if (jj_mask_0[getToken(1).kind]) {
        ;
      } else {
        break label_1;
      }
      jj_consume_token(UNDER);
      tmp = oneKey();
                                                               last.next = tmp; last = tmp;
    }
    return first;
  }

  static boolean[] jj_mask_0 = new boolean[36];
  static {
    jj_mask_0[UNDER] = true;
  }
  
  static final public KeyCode oneKey() throws ParseError {
  int mod = 0;
  int ignore = 0;
  int t;
    label_2:
    while (true) {
      if (jj_2_1(2)) {
        ;
      } else {
        break label_2;
      }
      t = modifiersPart();
                                        if (t < 0) ignore |= (-t); else mod |= t;
    }
    t = keyCode();
                   return new KeyCode (mod, ignore, t);
  }

  static final public int modifiersPart() throws ParseError {
  int mod = 0;
    if (jj_mask_3[getToken(1).kind]) {
      jj_consume_token(SHIFT);
             mod |= KeyCode.SHIFT;
    } else {
      if (jj_mask_2[getToken(1).kind]) {
        jj_consume_token(CTRL);
                                                 mod |= KeyCode.CTRL;
      } else {
        if (jj_mask_1[getToken(1).kind]) {
          jj_consume_token(ALT);
                                                                                  mod |= KeyCode.ALT;
        } else {
          jj_consume_token(-1);
          throw new ParseError();
        }
      }
    }
    if (jj_mask_5[getToken(1).kind]) {
      jj_consume_token(PLUS);
            return mod;
    } else {
      if (jj_mask_4[getToken(1).kind]) {
        jj_consume_token(MINUS);
                                      return -mod;
      } else {
        jj_consume_token(-1);
        throw new ParseError();
      }
    }
  }

  static boolean[] jj_mask_1 = new boolean[36];
  static {
    jj_mask_1[ALT] = true;
  }
  static boolean[] jj_mask_2 = new boolean[36];
  static {
    jj_mask_2[CTRL] = true;
  }
  static boolean[] jj_mask_3 = new boolean[36];
  static {
    jj_mask_3[SHIFT] = true;
  }
  static boolean[] jj_mask_4 = new boolean[36];
  static {
    jj_mask_4[MINUS] = true;
  }
  static boolean[] jj_mask_5 = new boolean[36];
  static {
    jj_mask_5[PLUS] = true;
  }
  
  static final public int keyCode() throws ParseError {
  Token t;
    if (jj_mask_36[getToken(1).kind]) {
      t = jj_consume_token(ALPHA);
                return t.image.charAt (0);
    } else {
      if (jj_mask_35[getToken(1).kind]) {
        if (jj_mask_34[getToken(1).kind]) {
          t = jj_consume_token(SHIFT);
        } else {
          if (jj_mask_33[getToken(1).kind]) {
            t = jj_consume_token(CTRL);
          } else {
            if (jj_mask_32[getToken(1).kind]) {
              t = jj_consume_token(ALT);
            } else {
              jj_consume_token(-1);
              throw new ParseError();
            }
          }
        }
                                           return t.image.charAt (0);
      } else {
        if (jj_mask_31[getToken(1).kind]) {
          jj_consume_token(10);
           return Event.HOME;
        } else {
          if (jj_mask_30[getToken(1).kind]) {
            jj_consume_token(11);
          return Event.END;
          } else {
            if (jj_mask_29[getToken(1).kind]) {
              jj_consume_token(12);
           return Event.LEFT;
            } else {
              if (jj_mask_28[getToken(1).kind]) {
                jj_consume_token(13);
            return Event.RIGHT;
              } else {
                if (jj_mask_27[getToken(1).kind]) {
                  jj_consume_token(14);
           return Event.DOWN;
                } else {
                  if (jj_mask_26[getToken(1).kind]) {
                    jj_consume_token(15);
         return Event.UP;
                  } else {
                    if (jj_mask_25[getToken(1).kind]) {
                      jj_consume_token(16);
           return Event.PGUP;
                    } else {
                      if (jj_mask_24[getToken(1).kind]) {
                        jj_consume_token(17);
           return Event.PGDN;
                      } else {
                        if (jj_mask_23[getToken(1).kind]) {
                          jj_consume_token(18);
          return '\t';
                        } else {
                          if (jj_mask_22[getToken(1).kind]) {
                            jj_consume_token(19);
            return '\n';
                          } else {
                            if (jj_mask_21[getToken(1).kind]) {
                              jj_consume_token(20);
          return 27;
                            } else {
                              if (jj_mask_20[getToken(1).kind]) {
                                jj_consume_token(21);
          return 127;
                              } else {
                                if (jj_mask_19[getToken(1).kind]) {
                                  jj_consume_token(22);
             return '\b';
                                } else {
                                  if (jj_mask_18[getToken(1).kind]) {
                                    jj_consume_token(23);
            return ' ';
                                  } else {
                                    if (jj_mask_17[getToken(1).kind]) {
                                      jj_consume_token(24);
         return Event.F1;
                                    } else {
                                      if (jj_mask_16[getToken(1).kind]) {
                                        jj_consume_token(25);
         return Event.F2;
                                      } else {
                                        if (jj_mask_15[getToken(1).kind]) {
                                          jj_consume_token(26);
         return Event.F3;
                                        } else {
                                          if (jj_mask_14[getToken(1).kind]) {
                                            jj_consume_token(27);
         return Event.F4;
                                          } else {
                                            if (jj_mask_13[getToken(1).kind]) {
                                              jj_consume_token(28);
         return Event.F5;
                                            } else {
                                              if (jj_mask_12[getToken(1).kind]) {
                                                jj_consume_token(29);
         return Event.F6;
                                              } else {
                                                if (jj_mask_11[getToken(1).kind]) {
                                                  jj_consume_token(30);
         return Event.F7;
                                                } else {
                                                  if (jj_mask_10[getToken(1).kind]) {
                                                    jj_consume_token(31);
         return Event.F8;
                                                  } else {
                                                    if (jj_mask_9[getToken(1).kind]) {
                                                      jj_consume_token(32);
         return Event.F9;
                                                    } else {
                                                      if (jj_mask_8[getToken(1).kind]) {
                                                        jj_consume_token(33);
          return Event.F10;
                                                      } else {
                                                        if (jj_mask_7[getToken(1).kind]) {
                                                          jj_consume_token(34);
          return Event.F11;
                                                        } else {
                                                          if (jj_mask_6[getToken(1).kind]) {
                                                            jj_consume_token(35);
          return Event.F12;
                                                          } else {
                                                            jj_consume_token(-1);
                                                            throw new ParseError();
                                                          }
                                                        }
                                                      }
                                                    }
                                                  }
                                                }
                                              }
                                            }
                                          }
                                        }
                                      }
                                    }
                                  }
                                }
                              }
                            }
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          }
        }
      }
    }
  }

  static boolean[] jj_mask_6 = new boolean[36];
  static {
    jj_mask_6[35] = true;
  }
  static boolean[] jj_mask_7 = new boolean[36];
  static {
    jj_mask_7[34] = true;
  }
  static boolean[] jj_mask_8 = new boolean[36];
  static {
    jj_mask_8[33] = true;
  }
  static boolean[] jj_mask_9 = new boolean[36];
  static {
    jj_mask_9[32] = true;
  }
  static boolean[] jj_mask_10 = new boolean[36];
  static {
    jj_mask_10[31] = true;
  }
  static boolean[] jj_mask_11 = new boolean[36];
  static {
    jj_mask_11[30] = true;
  }
  static boolean[] jj_mask_12 = new boolean[36];
  static {
    jj_mask_12[29] = true;
  }
  static boolean[] jj_mask_13 = new boolean[36];
  static {
    jj_mask_13[28] = true;
  }
  static boolean[] jj_mask_14 = new boolean[36];
  static {
    jj_mask_14[27] = true;
  }
  static boolean[] jj_mask_15 = new boolean[36];
  static {
    jj_mask_15[26] = true;
  }
  static boolean[] jj_mask_16 = new boolean[36];
  static {
    jj_mask_16[25] = true;
  }
  static boolean[] jj_mask_17 = new boolean[36];
  static {
    jj_mask_17[24] = true;
  }
  static boolean[] jj_mask_18 = new boolean[36];
  static {
    jj_mask_18[23] = true;
  }
  static boolean[] jj_mask_19 = new boolean[36];
  static {
    jj_mask_19[22] = true;
  }
  static boolean[] jj_mask_20 = new boolean[36];
  static {
    jj_mask_20[21] = true;
  }
  static boolean[] jj_mask_21 = new boolean[36];
  static {
    jj_mask_21[20] = true;
  }
  static boolean[] jj_mask_22 = new boolean[36];
  static {
    jj_mask_22[19] = true;
  }
  static boolean[] jj_mask_23 = new boolean[36];
  static {
    jj_mask_23[18] = true;
  }
  static boolean[] jj_mask_24 = new boolean[36];
  static {
    jj_mask_24[17] = true;
  }
  static boolean[] jj_mask_25 = new boolean[36];
  static {
    jj_mask_25[16] = true;
  }
  static boolean[] jj_mask_26 = new boolean[36];
  static {
    jj_mask_26[15] = true;
  }
  static boolean[] jj_mask_27 = new boolean[36];
  static {
    jj_mask_27[14] = true;
  }
  static boolean[] jj_mask_28 = new boolean[36];
  static {
    jj_mask_28[13] = true;
  }
  static boolean[] jj_mask_29 = new boolean[36];
  static {
    jj_mask_29[12] = true;
  }
  static boolean[] jj_mask_30 = new boolean[36];
  static {
    jj_mask_30[11] = true;
  }
  static boolean[] jj_mask_31 = new boolean[36];
  static {
    jj_mask_31[10] = true;
  }
  static boolean[] jj_mask_32 = new boolean[36];
  static {
    jj_mask_32[ALT] = true;
  }
  static boolean[] jj_mask_33 = new boolean[36];
  static {
    jj_mask_33[CTRL] = true;
  }
  static boolean[] jj_mask_34 = new boolean[36];
  static {
    jj_mask_34[SHIFT] = true;
  }
  static boolean[] jj_mask_35 = new boolean[36];
  static {
    jj_mask_35[SHIFT] =
    jj_mask_35[CTRL] =
    jj_mask_35[ALT] = true;
  }
  static boolean[] jj_mask_36 = new boolean[36];
  static {
    jj_mask_36[ALPHA] = true;
  }
  
  static final private boolean jj_2_1(int xla) throws ParseError {
    jj_la = xla; jj_lastpos = jj_scanpos = token;
    return !jj_3_1();
  }

  static final private boolean jj_3_1() throws ParseError {
    if (jj_3R_3()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_3() throws ParseError {
    Token xsp;
    xsp = jj_scanpos;
    if (jj_3R_4()) {
    jj_scanpos = xsp;
    if (jj_3R_5()) {
    jj_scanpos = xsp;
    if (jj_3R_6()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    xsp = jj_scanpos;
    if (jj_3R_7()) {
    jj_scanpos = xsp;
    if (jj_3R_8()) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    } else if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_4() throws ParseError {
    if (jj_scan_token(SHIFT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_5() throws ParseError {
    if (jj_scan_token(CTRL)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_6() throws ParseError {
    if (jj_scan_token(ALT)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_7() throws ParseError {
    if (jj_scan_token(PLUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static final private boolean jj_3R_8() throws ParseError {
    if (jj_scan_token(MINUS)) return true;
    if (jj_la == 0 && jj_scanpos == jj_lastpos) return false;
    return false;
  }

  static private boolean jj_initialized_once = false;
  static public KeyTokenManager token_source;
  static public Token token;
  static private Token jj_scanpos, jj_lastpos;
  static private int jj_la;
  static public boolean lookingAhead = false;
  static private boolean jj_semLA;

  public Key(java.io.InputStream stream) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    ASCII_CharStream input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source = new KeyTokenManager(input_stream);
    token = new Token();
  }

  static public void ReInit(java.io.InputStream stream) {
    ASCII_CharStream input_stream = new ASCII_CharStream(stream, 1, 1);
    token_source.ReInit(input_stream);
    token = new Token();
  }

  public Key(KeyTokenManager tm) {
    if (jj_initialized_once) {
      System.out.println("ERROR: Second call to constructor of static parser.  You must");
      System.out.println("       either use ReInit() or set the JavaCC option STATIC to false");
      System.out.println("       during parser generation.");
      throw new Error();
    }
    jj_initialized_once = true;
    token_source = tm;
    token = new Token();
  }

  public void ReInit(KeyTokenManager tm) {
    token_source = tm;
    token = new Token();
  }

  static final private Token jj_consume_token(int kind) throws ParseError {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    if (token.kind == kind) {
      return token;
    }
    jj_token_error_setup(token, kind);
    throw new ParseError();
  }

  static final private boolean jj_scan_token(int kind) throws ParseError {
    if (jj_scanpos == jj_lastpos) {
      jj_la--;
      if (jj_scanpos.next == null) {
        jj_lastpos = jj_scanpos = jj_scanpos.next = token_source.getNextToken();
      } else {
        jj_lastpos = jj_scanpos = jj_scanpos.next;
      }
    } else {
      jj_scanpos = jj_scanpos.next;
    }
    return (jj_scanpos.kind != kind);
  }

  static final public Token getNextToken() throws ParseError {
    if (token.next != null) token = token.next;
    else token = token.next = token_source.getNextToken();
    return token;
  }

  static final public Token getToken(int index) throws ParseError {
    Token t = lookingAhead ? jj_scanpos : token;
    for (int i = 0; i < index; i++) {
      if (t.next != null) t = t.next;
      else t = t.next = token_source.getNextToken();
    }
    return t;
  }

  static final String jj_add_escapes(String str) {
    String retval = "";
    char ch;
    for (int i = 0; i < str.length(); i++) {
      ch = str.charAt(i);
      if (ch == '\b') {
        retval += "\\b";
      } else if (ch == '\t') {
        retval += "\\t";
      } else if (ch == '\n') {
        retval += "\\n";
      } else if (ch == '\f') {
        retval += "\\f";
      } else if (ch == '\r') {
        retval += "\\r";
      } else if (ch == '\"') {
        retval += "\\\"";
      } else if (ch == '\'') {
        retval += "\\\'";
      } else if (ch == '\\') {
        retval += "\\\\";
      } else if (ch < 0x20 || ch > 0x7e) {
        String s = "0000" + Integer.toString(ch, 16);
        retval += "\\u" + s.substring(s.length() - 4, s.length());
      } else {
        retval += ch;
      }
    }
    return retval;
  }

  static final private void jj_token_error_setup(Token current, int kind) throws ParseError {
    int line = current.beginLine, column = current.beginColumn;
    System.out.println("Parse error at line " + line + ", column " + column + ".  Encountered: " + jj_add_escapes((current.kind == 0) ? tokenImage[0] : current.image));
  }

  static final public void enable_tracing() {
  }

  static final public void disable_tracing() {
  }

}
