/** FormatedOutput interface
* @author: Filip Dvorak
* @version: 1.0
*/

package xelfi.execution;

public interface FormatedOutput
{
    /** Print a line of text and append newline character. 
     @param text string to print
     */
  void printline(String text);

    /** Print a text. 
     @param text string to print
     */
  void printtext(String text);

    /** Close the output. */
  void close();
}
