/**
* Xelfi programming environment
*/

package xelfi.editor;
import java.awt.Font;
import java.awt.Color;

/**
* Can contain informations about the way how documents
* can be painted.
*
* @version 1.0
* @author Jaroslav Tulach
*/

public class TextDrawInfo extends Object {
  /** end of text that should be drawn by this settings */
  public Position end;
  
  /** the font that will be used to draw following text */
  public Font font;

  /** the color of text */
  public Color text;

  /** the color of background */
  public Color back;
};


