package xelfi.editor.keys;

public interface KeyConfigConstants {

  int EOF = 0;
  int SINGLE_LINE_COMMENT = 6;
  int FORMAL_COMMENT = 7;
  int MULTI_LINE_COMMENT = 8;
  int IMPORT = 9;
  int MACRO = 10;
  int KEY = 11;
  int DOT = 12;
  int AST = 13;
  int STRED = 14;
  int EQUAL = 15;
  int BEGIN = 16;
  int END = 17;
  int KEY_LITERAL = 18;
  int INTEGER_LITERAL = 19;
  int CHARACTER_LITERAL = 20;
  int STRING_LITERAL = 21;
  int IDENTIFIER = 22;
  int LETTER = 23;
  int DIGIT = 24;

  int DEFAULT = 0;

  String[] tokenImage = {
    "<EOF>",
    "\" \"",
    "\"\\t\"",
    "\"\\n\"",
    "\"\\r\"",
    "\"\\f\"",
    "<SINGLE_LINE_COMMENT>",
    "<FORMAL_COMMENT>",
    "<MULTI_LINE_COMMENT>",
    "\"import\"",
    "\"macro\"",
    "\"key\"",
    "\".\"",
    "\"*\"",
    "\";\"",
    "\"=\"",
    "\"{\"",
    "\"}\"",
    "<KEY_LITERAL>",
    "<INTEGER_LITERAL>",
    "<CHARACTER_LITERAL>",
    "<STRING_LITERAL>",
    "<IDENTIFIER>",
    "<LETTER>",
    "<DIGIT>",
  };

}
